/* ********************************************************/
/* ********************************************************/
/* *                                                    * */
/* *               BANG COMMAND SECTION                 * */
/* *                                                    * */
/* ********************************************************/
/* ********************************************************/

#include <windows.h>
#include "grdBangs.h"
#include "lsapi.h"

typedef void (*BANGCOMMAND)(HWND, char*);

grdBangs::grdBangs( HWND hTray, grdSysTraySettings *cfg ) {

	this->hSysTray = hTray;
	this->settings = cfg;

	AddBangCommand( "!grdTrayHide",   grdTrayHide   );
	AddBangCommand( "!grdTrayShow",   grdTrayShow   );
	AddBangCommand( "!grdTrayToggle", grdTrayToggle );
	AddBangCommand( "!grdTrayMove",   grdTrayMove   );

}

grdBangs::~grdBangs() {

	RemoveBangCommand( "!grdTrayHide"   );
	RemoveBangCommand( "!grdTrayShow"   );
	RemoveBangCommand( "!grdTrayToggle" );
	RemoveBangCommand( "!grdTrayMove"   );


}



void grdTrayHide( HWND hCaller, LPCTSTR pszArgs ) {

	HWND hSysTray = FindWindow( WC_SYSTRAY, NULL );
	ShowWindow( hSysTray, SW_HIDE );

}

void grdTrayShow( HWND hCaller, LPCTSTR pszArgs ) {

	HWND hSysTray = FindWindow( WC_SYSTRAY, NULL );
	ShowWindow( hSysTray, SW_SHOWNOACTIVATE );

}

void grdTrayToggle( HWND hCaller, LPCTSTR pszArgs ) {

	HWND hSysTray = FindWindow( WC_SYSTRAY, NULL );
	BOOL visible = IsWindowVisible( hSysTray );
    ShowWindow( hSysTray, ( (visible) ? SW_SHOWNOACTIVATE : SW_HIDE) );

}

void grdTrayMove( HWND hCaller, LPCTSTR pszArgs ) {

	HWND hSysTray = FindWindow( WC_SYSTRAY, NULL );
	char token1[256] = "";
	char token2[256] = "";
	char extra[256] = "";
	int x, y;

	char* tokens[2];

	tokens[0] = token1;
	tokens[1] = token2;

	LCTokenize( pszArgs, tokens, 2, extra );

	x = atoi( token1 );
    if( x < 0 )
        x += GetSystemMetrics(SM_CXSCREEN);

	y = atoi( token2 );
    if( x < 0 )
        x += GetSystemMetrics(SM_CYSCREEN);


	SetWindowPos( hSysTray, NULL, x, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE );

}



